Index: less/optfunc.c
diff -u less/optfunc.c:1.1.1.10 less/optfunc.c:1.14
--- less/optfunc.c:1.1.1.10	Sun Dec  1 05:40:54 1996
+++ less/optfunc.c	Sat Jan 25 07:12:42 1997
@@ -2,6 +2,9 @@
  * Copyright (c) 1984,1985,1989,1994,1995,1996  Mark Nudelman
  * All rights reserved.
  *
+ * Copyright (c) 1997  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -76,6 +79,9 @@
 extern int so_fg_color, so_bg_color;
 extern int bl_fg_color, bl_bg_color;
 #endif
+#if JAPANESE
+extern int opt_Z_var;
+#endif
 
 
 #if LOGFILE
@@ -360,6 +366,48 @@
 		break;
 	}
 }
+
+#if JAPANESE
+/*
+ * Handler for the -Z option.
+ */
+	/*ARGSUSED*/
+	public void
+opt_Z(type, s)
+	int type;
+	char *s;
+{
+	switch (type)
+	{
+	case INIT:
+		if (opt_Z_var == OPT_ON)
+			init_def_priority(sjis);
+		else if (opt_Z_var == OPT_OFF)
+			init_def_priority(ujis);
+		break;
+	case QUERY:
+		break;
+	case TOGGLE:
+		switch (get_priority(get_mulbuf(curr_ifile))) {
+		case sjis:
+			opt_Z_var = OPT_OFF;
+			break;
+		case ujis:
+			opt_Z_var = OPT_ON;
+			break;
+		case noconv:
+			opt_Z_var = OPT_ONPLUS;	/* we use this to mean error */
+			return;
+		}
+		if (opt_Z_var == OPT_ON)
+			init_def_priority(sjis);
+		else if (opt_Z_var == OPT_OFF)
+			init_def_priority(ujis);
+		init_priority(get_mulbuf(curr_ifile));
+		break;
+	}
+}
+#endif
 
 /*
  * Handler for the -V option.
Index: less/option.c
diff -u less/option.c:1.1.1.6 less/option.c:1.11
--- less/option.c:1.1.1.6	Sun Dec  1 05:40:55 1996
+++ less/option.c	Sun Jan 12 18:16:16 1997
@@ -2,6 +2,9 @@
  * Copyright (c) 1984,1985,1989,1994,1995,1996  Mark Nudelman
  * All rights reserved.
  *
+ * Copyright (c) 1997  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -408,7 +411,7 @@
 {
 	static char buf[8];
 
-	sprintf(buf, "-%s", prchar(c));
+	sprintf(buf, "-%s", prchar(c, ASCII));
 	return (buf);
 }
 
Index: less/opttbl.c
diff -u less/opttbl.c:1.1.1.10 less/opttbl.c:1.16
--- less/opttbl.c:1.1.1.10	Sun Dec  1 05:40:56 1996
+++ less/opttbl.c	Sat Jan 25 07:12:43 1997
@@ -2,6 +2,9 @@
  * Copyright (c) 1984,1985,1989,1994,1995,1996  Mark Nudelman
  * All rights reserved.
  *
+ * Copyright (c) 1997  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -61,6 +64,9 @@
 #if HILITE_SEARCH
 public int hilite_search;	/* Highlight matched search patterns? */
 #endif
+#if JAPANESE
+public int opt_Z_var;		/* Initial variable for opt_Z */
+#endif
 
 /*
  * Table of all options and their semantics.
@@ -222,6 +228,18 @@
 		"Scroll window size is %d lines",
 		NULL
 	},
+#if JAPANESE
+#ifdef SJIS_PRE
+#define OPT_Z OPT_ON
+#else
+#define OPT_Z OPT_OFF
+#endif
+	{ 'Z', BOOL|REPAINT, OPT_Z, &opt_Z_var, opt_Z,
+		"Give priority to the UJIS over the SJIS",
+		"Give priority to the SJIS over the UJIS",
+		"Cannot give priority since Japanese was not treated now",
+	},
+#endif
 	{ '"', STRING, 0, NULL, opt_quote,
 		"quotes: ", NULL, NULL
 	},
@@ -248,6 +266,12 @@
 		if (o->ovar != NULL)
 			*(o->ovar) = o->odefault;
 	}
+#if JAPANESE
+	if (opt_Z_var == OPT_ON)
+		init_def_priority(sjis);
+	else if (opt_Z_var == OPT_OFF)
+		init_def_priority(ujis);
+#endif
 }
 
 /*
Index: less/output.c
diff -u less/output.c:1.1.1.9 less/output.c:1.25
--- less/output.c:1.1.1.9	Sun Dec  1 05:40:57 1996
+++ less/output.c	Wed Jan 22 21:12:01 1997
@@ -2,6 +2,9 @@
  * Copyright (c) 1984,1985,1989,1994,1995,1996  Mark Nudelman
  * All rights reserved.
  *
+ * Copyright (c) 1997  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -53,6 +56,7 @@
 	register int c;
 	register int i;
 	int a;
+	int cs;
 	int curr_attr;
 
 	if (ABORT_SIGS())
@@ -66,7 +70,7 @@
 
 	curr_attr = AT_NORMAL;
 
-	for (i = 0;  (c = gline(i, &a)) != '\0';  i++)
+	for (i = 0;  (c = gline(i, &cs, &a)) != '\0';  i++)
 	{
 		if (a != curr_attr)
 		{
@@ -96,7 +100,11 @@
 		if (c == '\b')
 			putbs();
 		else
+#if ISO
+			putmchr(c, cs);
+#else
 			putchr(c);
+#endif
 	}
 
 	switch (curr_attr)
@@ -208,7 +216,7 @@
  * Output a character.
  */
 	public int
-putchr(c)
+putchr_raw(c)
 	int c;
 {
 	if (need_clr)
@@ -218,11 +226,11 @@
 	}
 #if MSDOS_COMPILER
 	if (c == '\n' && is_tty)
-		putchr('\r');
+		putchr_raw('\r');
 #else
 #ifdef _OSK
 	if (c == '\n' && is_tty)  /* In OS-9, '\n' == 0x0D */
-		putchr(0x0A);
+		putchr_raw(0x0A);
 #endif
 #endif
 	/*
@@ -239,11 +247,85 @@
  * Output a string.
  */
 	public void
-putstr(s)
+putstr_raw(s)
 	register char *s;
 {
 	while (*s != '\0')
-		putchr(*s++);
+		putchr_raw(*s++);
+}
+
+/*
+ * Output a character as ASCII.
+ */
+	public int
+putchr(c)
+	int c;
+{
+#if ISO
+	char *p = outchar(c & 0377, ASCII);
+	putstr_raw(p);
+	return (c);
+#else
+	return (putchr_raw(c));
+#endif
+}
+
+/*
+ * Output a string as ASCII.
+ */
+	public void
+putstr(s)
+	char *s;
+{
+#if ISO
+	char *p = outbuf(s, ASCII);
+	putstr_raw(p);
+#else
+	putstr_raw(s);
+#endif
+}
+
+/*
+ * Output a character which is a part of multi-bytes character.
+ */
+	public int
+putmchr(c, cs)
+	int c;
+	CHARSET cs;
+{
+#if ISO
+	char *p = outchar(c & 0377, cs);
+	putstr_raw(p);
+#else
+	putchr_raw(c);
+#endif
+	return (c);
+}
+
+/*
+ * Output a part of multi-bytes character.
+ */
+	public int
+putmchrs(s, cs)
+	char *s;
+	CHARSET cs;
+{
+	int c = *s;
+	while (*s != '\0')
+		putmchr(*s++, cs);
+	return (c);
+}
+
+/*
+ * Output a string of multi-bytes character.
+ */
+	public void
+putmstr(s, cs)
+	char *s;
+	CHARSET *cs;
+{
+	while (*s != '\0')
+		putmchr(*s++, *cs++);
 }
 
 
Index: less/prompt.c
diff -u less/prompt.c:1.1.1.8 less/prompt.c:1.14
--- less/prompt.c:1.1.1.8	Sun Dec  1 05:40:58 1996
+++ less/prompt.c	Sun Jan 12 18:16:18 1997
@@ -2,6 +2,9 @@
  * Copyright (c) 1984,1985,1989,1994,1995,1996  Mark Nudelman
  * All rights reserved.
  *
+ * Copyright (c) 1997  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -60,8 +63,8 @@
   "?n?f%f .?m(file %i of %m) ..?e(END) ?x- Next\\: %x.:?pB%pB\\%:byte %bB?s/%s...%t";
 static constant char M_proto[] =
   "?f%f .?n?m(file %i of %m) ..?ltline %lt?L/%L. :byte %bB?s/%s. .?e(END) ?x- Next\\: %x.:?pB%pB\\%..%t";
-static constant char e_proto[] =
-  "?f%f .?m(file %i of %m) .?ltline %lt?L/%L. .byte %bB?s/%s. ?e(END) :?pB%pB\\%..%t";
+static char e_proto[] =
+  "?f%f .?m(file %i of %m) .?ltline %lt?L/%L. .byte %bB?s/%s. ?e(END) :?pB%pB\\%.. code %K%t";
 static constant char h_proto[] =
   "HELP -- ?eEND -- Press g to see it again:Press RETURN for more., or q when done";
 
@@ -282,6 +285,13 @@
 			free(s);
 		} else
 			ap_quest();
+		break;
+	case 'K':	/* Character set or code set of last non ASCII char. */
+#if ISO
+		ap_str(get_icharset_string(get_mulbuf(curr_ifile)));
+#else
+		ap_str("");
+#endif
 		break;
 	}
 }
Index: less/search.c
diff -u less/search.c:1.1.1.12 less/search.c:1.26
--- less/search.c:1.1.1.12	Sun Dec  1 05:40:59 1996
+++ less/search.c	Tue Jan 21 22:51:42 1997
@@ -2,6 +2,9 @@
  * Copyright (c) 1984,1985,1989,1994,1995,1996  Mark Nudelman
  * All rights reserved.
  *
+ * Copyright (c) 1997  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -55,6 +58,10 @@
 #if HAVE_V8_REGCOMP
 #include "regexp.h"
 #endif
+#ifndef UJIS_REGEXP
+#define UJIS_REGEXP 0
+#endif
+
 
 static int match();
 
@@ -65,6 +72,7 @@
 extern int sc_height;
 extern int jump_sline;
 extern int bs_mode;
+extern IFILE curr_ifile;
 #if HILITE_SEARCH
 extern int hilite_search;
 extern int screen_trashed;
@@ -102,18 +110,108 @@
 #endif
 
 static int is_caseless;
+static int is_nascii_pattern;
 static int is_ucase_pattern;
 static int last_search_type;
 static char *last_pattern = NULL;
 
+#if ISO
+/*
+ * Normalize text.  Add quote some non ASCII characters which are
+ * mean that special in regexp.
+ */
+	static char *
+normalize_text(src, cs, search_type)
+	char *src;
+	CHARSET *cs;
+	int search_type;
+{
+	char *odst = (char *) ecalloc(strlen(src) * 2, sizeof(char));
+	register char *dst = odst;
+
+	while (*src != '\0')
+	{
+#if !NO_REGEX && ISO
+#if UJIS_REGEXP
+		switch (CS2CHARSET(*cs++)) {
+		case JISX0208_78KANJI:
+		case JISX0208KANJI:
+		case JISX0208_90KANJI:
+			*dst++ = *src++ | 0x80;
+			break;
+		default:
+			*dst++ = *src++;
+			break;
+		}
+#else
+		if (!ISASCII(*cs++) && !(search_type & SRCH_NO_REGEX))
+		{
+			switch (*src) {
+			/* Basic Regular Expressions */
+			case '[':
+			case ']':
+			case '.':
+			case '*':
+			case '\\':
+			case '^':
+			case '$':
+#if HAVE_POSIX_REGCOMP && defined(REG_EXTENDED)
+			/* Extended Regular Expressions */
+			case '+':
+			case '?':
+			case '|':
+			case '(':
+			case ')':
+			case '{':
+			case '}':
+#endif
+#if HAVE_RE_COMP
+			/* No Extended Regular Expressions */
+#endif
+#if HAVE_REGCMP
+			/* Extended Regular Expressions */
+			case '+':
+			case '(':
+			case ')':
+			case '{':
+			case '}':
+#endif
+#if HAVE_V8_REGCOMP
+			/* Extended Regular Expressions */
+			case '+':
+			case '?':
+			case '|':
+			case '(':
+			case ')':
+#endif
+				*dst++ = '\\';
+				/* fall through */
+			default:
+				*dst++ = *src++;
+				break;
+			}
+		} else
+			*dst++ = *src++;
+#endif
+#else
+		*dst++ = *src++;
+#endif
+	}
+	*dst = '\0';
+	return (odst);
+}
+#endif
+
 /*
  * Convert text.  Perform one or more of these transformations:
  */
 #define	CVT_TO_LC	01	/* Convert upper-case to lower-case */
 #define	CVT_BS		02	/* Do backspace processing */
+#define	CVT_TO_INT	04	/* Convert all multi bytes characters into */
+				/* internal form */
 
 	static void
-cvt_text(odst, osrc, ops)
+cvt_text_ascii(odst, osrc, ops)
 	char *odst;
 	char *osrc;
 	int ops;
@@ -132,21 +230,135 @@
 		else 
 			/* Just copy. */
 			*dst = *src;
+ 	}
+	*dst = '\0';
+}
+
+	static void
+cvt_text(odst, dstcs, osrc, srccs, ops)
+	char *odst;
+	CHARSET *dstcs;
+	char *osrc;
+	CHARSET *srccs;
+	int ops;
+{
+	register char *dst;
+	register char *src;
+	int bufcount;
+	char *cbuf;
+	CHARSET *csbuf;
+
+	if (!(ops & CVT_TO_INT) && srccs == NULL || !ISO)
+	{
+		cvt_text_ascii(odst, osrc, ops);
+		if (dstcs)
+			while (*odst++ != '\0')
+				*dstcs++ = ASCII;
+		return;
+	}
+
+#if ISO
+	if (ops & CVT_TO_INT)
+		prewind_multi(get_mulbuf(curr_ifile), ch_tell());
+
+	for (src = osrc, dst = odst;  *src != '\0';
+	     src++, dst++, srccs && srccs++, dstcs && dstcs++)
+	{
+		if ((ops & CVT_TO_INT) && srccs == NULL)
+		{
+			/* make charset */
+			buffering_multi(get_mulbuf(curr_ifile),
+					(unsigned char) *src,
+					&cbuf, &csbuf, &bufcount);
+			if (bufcount == 0)
+			{
+				*dst = '\1';
+				if (dstcs)
+					*dstcs = ASCII;
+				continue;
+			}
+		} else
+		{
+			static CHARSET dummy_cs[] = { ASCII };
+			bufcount = 1;
+			cbuf = src;
+			csbuf = srccs ? srccs : dummy_cs;
+		}
+
+		while (--bufcount >= 0)
+		{
+#if UJIS_REGEXP
+			if (!ISASCII(*csbuf))
+				*cbuf |= 0x80;
+#endif
+			if ((ops & CVT_TO_LC) && ISASCII(*csbuf) &&
+			    isupper((unsigned char) *cbuf))
+			{
+				/* Convert uppercase to lowercase. */
+				dst[-bufcount] = tolower((unsigned char) *cbuf);
+				if (dstcs)
+					dstcs[-bufcount] = *csbuf;
+			} else if ((ops & CVT_BS) &&
+				   *cbuf == '\b' && dst > odst)
+			{
+				/* Delete BS and preceding char. */
+				if (bufcount == 0)
+				{
+					dst -= 2;
+					if (dstcs)
+						dstcs -= 2;
+				} else
+				{
+					dst -= 1;
+					if (dstcs)
+						dstcs -= 2;
+				}
+			} else 
+			{
+				/* Just copy. */
+				dst[-bufcount] = *cbuf;
+				if (dstcs)
+					dstcs[-bufcount] = *csbuf;
+			}
+			cbuf++;
+			csbuf++;
+		}
 	}
 	*dst = '\0';
+
+	if (ops & CVT_TO_INT)
+		pdone_multi(get_mulbuf(curr_ifile), ch_tell());
+#endif
 }
 
 /*
  * Are there any uppercase letters in this string?
  */
 	static int
-is_ucase(s)
+is_ucase(s, cs)
 	char *s;
+	CHARSET *cs;
 {
 	register char *p;
 
-	for (p = s;  *p != '\0';  p++)
-		if (isupper((unsigned char) *p))
+	for (p = s;  *p != '\0';  p++, cs++)
+		if (ISASCII(*cs) && isupper((unsigned char) *p))
+			return (1);
+	return (0);
+}
+
+/*
+ * Are there any character which is not ASCII?
+ */
+	static int
+is_nascii(s, cs)
+	char *s;
+	CHARSET *cs;
+{
+	register char *p;
+
+	for (p = s;  *p != '\0';  p++, cs++)
+		if (!ISASCII(*cs))
 			return (1);
 	return (0);
 }
@@ -548,8 +760,9 @@
 			 * forward by 2 relative to the processed line
 			 * which was searched in hilite_line.
 			 */
-			npos += 2;
-			line += 2;
+			opos--;
+			npos++;
+			line++;
 		}
 	}
 }
@@ -765,6 +978,9 @@
 	int line_match;
 	POSITION linepos, oldpos;
 
+	static CHARSET *charset = NULL;
+	static int charset_len = 0;
+
 	linenum = find_linenum(pos);
 	oldpos = pos;
 	for (;;)
@@ -842,14 +1058,35 @@
 		 * If it's a caseless search, convert the line to lowercase.
 		 * If we're doing backspace processing, delete backspaces.
 		 */
-		if (is_caseless || bs_mode == BS_SPECIAL)
+		if (is_caseless || bs_mode == BS_SPECIAL || is_nascii_pattern)
 		{
 			int ops = 0;
+			int len;
+
 			if (is_caseless) 
 				ops |= CVT_TO_LC;
 			if (bs_mode == BS_SPECIAL)
 				ops |= CVT_BS;
-			cvt_text(line, line, ops);
+			if (is_nascii_pattern) 
+				ops |= CVT_TO_INT;
+
+			cvt_text(line, NULL, line, NULL, ops);
+#if 0
+			/* Currently we can make charset like following, */
+			/* but there is no regexp routine which understand */
+			/* it.  Thus we don't make it. */
+			len = (strlen(line) + 1023) / 1024 * 1024;
+			if (len > charset_len)
+			{
+				charset_len = len;
+				if (charset)
+					free(charset);
+				charset = (CHARSET *)
+					ecalloc(len, sizeof(CHARSET));
+			}
+
+			cvt_text(line, charset, line, NULL, ops);
+#endif
 		}
 
 		/*
@@ -911,9 +1148,10 @@
  * if less than n matches are found in this file.
  */
 	public int
-search(search_type, pattern, n)
+search(search_type, pattern, charset, n)
 	int search_type;
 	char *pattern;
+	CHARSET *charset;
 	int n;
 {
 	POSITION pos;
@@ -960,11 +1198,18 @@
 		/*
 		 * Compile the pattern.
 		 */
-		ucase = is_ucase(pattern);
+		ucase = is_ucase(pattern, charset);
+		is_nascii_pattern = is_nascii(pattern, charset);
 		if (caseless == OPT_ONPLUS)
-			cvt_text(pattern, pattern, CVT_TO_LC);
+			cvt_text(pattern, NULL, pattern, charset, CVT_TO_LC);
+#if ISO
+		pattern = normalize_text(pattern, charset, search_type);
+#endif
 		if (compile_pattern(pattern, search_type) < 0)
 			return (-1);
+#if ISO
+		free(pattern);
+#endif
 		/*
 		 * Ignore case if -I is set OR
 		 * -i is set AND the pattern is all lowercase.
Index: less/version.c
diff -u less/version.c:1.1.1.13 less/version.c:1.48
--- less/version.c:1.1.1.13	Sun Dec  1 05:41:02 1996
+++ less/version.c	Sun Mar  9 22:59:21 1997
@@ -2,6 +2,9 @@
  * Copyright (c) 1984,1985,1989,1994,1995,1996  Mark Nudelman
  * All rights reserved.
  *
+ * Copyright (c) 1997  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
@@ -565,6 +568,34 @@
 		Add LESSMETACHARS, LESSMETAESCAPE.
 v330   10/21/96	Minor fixes.
 		Posted to Web page.
+-----------------------------------------------------------------
+   Other patches by jam@poboxes.com
+kanji  7/18/91	Support Kanji as one of the charset.
+zcat   4/21/94	Add easy uncompressing feature by invoking zcat.
+iso    8/11/94	Support ISO2022 encoding and special Japanese KANJI encodings
+		as one of the charset.
+iso2   9/21/94	Fix a variety of bugs of iso patch.
+iso2p1 10/22/94	Fix a variety of bugs.
+iso202 12/1/96  Chang to fit less version 330 and fixed some bugs.
+iso203 12/5/96  Fix line termination bug.
+iso204 12/15/96 Change all internal data structure.  Add CHARSET and
+		"CHARSET charset[]" in line.c.
+iso205 12/16/96 Add CODESET and structure of CODESET in multi.c and
+		made buffering_multi() recursively.
+iso206 12/21/96 Support multi bytes characters in command buffer.
+		And add rotate-right command for rotating the code set in the
+		right plane.
+iso207 12/22/96 Support search of multi bytes characters.
+iso208 12/23/96 Encapsulate multi bytes buffering data.  And change
+		the structure of CHARSET.
+iso209 1/5/97   Fix bugs of KANJI search and sophisticate SJIS routines.
+iso210 1/12/97  Fix BS handling and add priority argument of KANJI code.
+iso211 1/19/97  Add and change comments.
+iso212 1/21/97  Fix a bug about UJIS_REGEXP search.
+iso213 1/22/97  Fix a bug about 8-bit error message.
+iso214 1/24/97  Fix a bug about handling of BS character.
+iso215 1/25/97  Change to invert -Z option if SJIS_PRE is defined
+iso216 3/9/97   Fix a bug about buffering of KANJI supplement.
 */
 
-char version[] = "330";
+char version[] = "330+iso216";
